var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F09100;
(function (F09100) {
    var ExportRules = (function (_super) {
        __extends(ExportRules, _super);
        function ExportRules(document) {
            return _super.call(this, document) || this;
        }
        ExportRules.prototype.GetTables = function () {
            var result = [];
            result.push(this.GetObasData("\u041E\u0411\u0410\u0421"));
            result.push({ Id: "\u0420\u0430\u0441\u0445\u043E\u0434\u044B \u0432 \u0447\u0430\u0441\u0442\u0438 \u0440\u0435\u0437\u0435\u0440\u0432\u043D\u044B\u0445 \u0441\u0440\u0435\u0434\u0441\u0442\u0432", Data: [] });
            result.push(this.GetP2Sp2Data("\u041E\u0431\u044A\u0435\u043C \u0431\u044E\u0434\u0436\u0435\u0442\u043D\u044B\u0445 \u0430\u0441\u0441\u0438\u0433\u043D\u043E\u0432\u0430\u043D\u0438\u0439 \u0432 \u0447\u0430\u0441\u0442\u0438 \u0438\u043D\u044B\u0445 \u0440\u0435\u0437\u0435\u0440\u0432\u043D\u044B\u0445 \u0441\u0440\u0435\u0434\u0441\u0442\u0432"));
            result.push(this.GetSecretData("\u0413\u043E\u0441\u0442\u0430\u0439\u043D\u0430"));
            result.push(this.GetNpaData("\u041D\u041F\u0410"));
result.push(this.GetAnalyticKosguData("\u0410\u043D\u0430\u043B\u0438\u0442\u0438\u0447\u0435\u0441\u043A\u043E\u0435\u0420\u0430\u0441\u043F\u0440\u0435\u0434\u0435\u043B\u0435\u043D\u0438\u0435\u041A\u041E\u0421\u0413\u0423"));
            return result;
        };
        ExportRules.prototype.GetObasData = function (barsTableId) {
            var srcTable = this._document.TableP1;
            var srcData = [];
            var template = "<a ID=\"01\" ";
            for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
            }
            template += "/>";
            srcData.push(template);
            template = "<a ID=\"100\" b3=\"0\" b4=\"0\" b5=\"0\" />";
            srcData.push(template);
            for (var i = 1; i <= ObasStageSettings.YearsCount + 1; i++) {
                srcData.push("<c ID=\"SUM_" + i + "\" />");
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetP2Sp2Data = function (barsTableId) {
            var srcTable = this._document.TableP3;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.ReserveDirection.Value) + "\" ";
                for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                    template += "b" + (3 + j) + "=\"" + (srcTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
                }
                template += "b6=\"" + (srcTable.ReservCondition.Value) + "\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetNpaData = function (barsTableId) {
            var srcTable = this._document.TableP2Sp1;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                var template = "<a ID=\"" + i + "\" ";
                template += "b1=\"" + (srcTable.OwnerKey.SourceTable.ReserveDirection.Code || "") + "\" ";
                template += "b\u043F\u0440\u0438\u0437\u043D\u0430\u043A\u041F\u0440\u043E\u0435\u043A\u0442\u0430=\"True\" ";
                template += "bROWCODE=\"" + ObasHelper.FillWithCharacter((i + 1).toString(), 3) + "\" ";
                template += "bnpacolumn=\"" + (srcTable.NpaFields.NpaName.Value || "") + "\" ";
                template += "b6=\"" + (srcTable.NpaFields.NpaType.Code || "") + "\" ";
                template += "b7=\"" + (ObasHelper.ConvertToString(srcTable.NpaFields.NpaDate.Value) || "") + "\" ";
                template += "b8=\"" + (srcTable.NpaFields.NpaNumber.Value || "") + "\" ";
                template += "bstate=\"" + (srcTable.NpaStatus.Code || "") + "\" ";
                template += "bDateChanState=\"" + (ObasHelper.ConvertToString(srcTable.NpaStatusChangeDate.Value) || "") + "\" ";
                template += "/>";
                srcData.push(template);
                i++;
            }
            return { Id: barsTableId, Data: srcData };
        };
        ExportRules.prototype.GetAnalyticKosguData = function (barsTableId) {
            var srcTable = this._document.AnalyticsDataTable;
            var srcData = [];
            var i = 0;
            var reader = srcTable.CreateReader();
            while (reader.Read()) {
                if (srcTable.RecordKey.Value != 1) {
                    var template = "<a ID=\"" + i + "\" ";
                    template += "b2=\"" + (srcTable.Kosgu.Name) + "\" ";
                    template += "b3=\"" + (srcTable.Kosgu.Code) + "\" ";
                    for (var j = 0; j < ObasStageSettings.YearsCount; j++) {
                        template += "b" + (4 + j) + "=\"\"" + (srcTable.GetFieldValue("Y" + (j + 1).toString()) || 0) + "\" ";
                    }
                    template += "/>";
                    srcData.push(template);
                    i++;
                }
            }
            return { Id: barsTableId, Data: srcData };
        };
        return ExportRules;
    }(SimpleFormExportRules));
    F09100.ExportRules = ExportRules;
})(F09100 || (F09100 = {}));
